<?php
   
//    1.png
$encrypt = new crackCapcha('1.png'); 
echo "<br><span style='font-size: 25px;'>Resolve: ".$encrypt->resolve."</span><br><br>";
 
class crackCapcha {
 
  public $im;
  public $binaryMartix;
  public $assocNumber = array(
    '200' => 0,
    '86' => 1,
    '156' => 2,
    '180' => 3,
    '147' => 4,
    '184' => 5,
    '213' => 6,
    '118' => 7,
    '215' => 8,
    '209' => 9,
  );
  public $resolve;
 
 
  function __construct($path) {
    $this->im = @imagecreatefrompng($path);
 
    if (!$this->im){ 
      return false;
    }
     
    $this->binaryMartix =  $this->imageToMatrix($this->im, true);   
    $explode =  $this->explodeMatrix($this->binaryMartix);
    $this->resolve = '';
    foreach ($explode as $number) {
       $this->resolve .= $this->assocNumber[$number];
    } 
  }
 
 
  function explodeMatrix($binaryMartix) {
    $temp = array();
 
    //     
    for ($i = 0; $i < count($binaryMartix); $i++) {
      $sum = 0;
      for ($j = 0; $j < count($binaryMartix[0]); $j++) {
        $sum += $binaryMartix[$i][$j];
      }
      $temp[] = $sum ? 1 : 0;
    }
 
    //     
    $start = false;
    $countPart = 0;
    $arrayInterval = array();
    foreach ($temp as $k => $v) {
 
      if ($v == 1 && !$start) {
        $arrayInterval[$countPart]['start'] = $k;
        $start = true;
      }
 
      if ($v == 0 && $start) {
        $arrayInterval[$countPart]['end'] = $k - 1;
        $start = false;
        $countPart++;
      }
    }
 
    //       
    foreach ($arrayInterval as $interval) {
      $sum = 0;
      for ($i = 0; $i < count($binaryMartix); $i++) {
        for ($j = 0; $j < count($binaryMartix[0]); $j++) {
          if ($i >= $interval['start'] && $i <= $interval['end']) {
            $sum += $binaryMartix[$i][$j];
          }
        }
      }
      $result[] = $sum;
    }
 
    return $result;
  }
 
  /**
   *     
   *        1
   * @param imagecreatefrompng $im -    PNG
   * @param bool $rotate -     
   */
  function imageToMatrix($im, $rotate = false) {
    $height = imagesy($im);
    $width = imagesx($im);
 
    if ($rotate) {
      $height = imagesx($im);
      $width = imagesy($im);
    }
 
    $background = 0;
    for ($i = 0; $i < $height; $i++)
      for ($j = 0; $j < $width; $j++) {
 
        if ($rotate) {
          $rgb = imagecolorat($im, $i, $j);
        } else {
          $rgb = imagecolorat($im, $j, $i);
        }
 
        //   RGB 
        list($r, $g, $b) = array_values(imageColorsForIndex($im, $rgb));
 
        //  ,   
        if ($i == 0 && $j == 0) {
          $background = $r;
        }
 
        //         
        $binary[$i][$j] = ($r == $background) ? 0 : 1;
      }
    return $binary;
  }
 
  /**
   *    
   * @param type $binaryMartix
   */
  function printMatrix($binaryMartix) {
    for ($i = 0; $i < count($binaryMartix); $i++) {
      echo "<br/>";
      for ($j = 0; $j < count($binaryMartix[0]); $j++) {
        echo $binaryMartix[$i][$j]." ";
      }
    }
  }
 
}